<script setup lang="ts">
import BaseModal from "@/components/molecules/modal/BaseModal.vue";
import {useRepositoryNewVersionModalStore} from "@/stores/Repository/RepositoryNewVersionModalStore";
import {onMounted, ref, watch} from "vue";
import Flex from "@/components/atoms/container/Flex.vue";
import {type PreparedVersion} from "@/entities/Repository/PreparedVersion";
import ActionButton from "@/components/atoms/button/ActionButton.vue";
import RepositoryNewVersionLine
  from "@/components/organisms/list/Repository/RepositoryNewVersionLine/RepositoryNewVersionLine.vue";
import FormWithoutButton from "@/components/atoms/form/FormWithoutButton.vue";
import {useVersionTypeEnumStore} from "@/stores/Enum/VersionTypeEnumStore";
import {useUpdateTypeEnumStore} from "@/stores/Enum/UpdateTypeEnumStore";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import {useSnackbarStore} from "@/stores/Snackbar/SnackbarStore";

const modalData = useRepositoryNewVersionModalStore();
const updateTypeEnumStore = useUpdateTypeEnumStore();
const versionTypeEnumStore = useVersionTypeEnumStore();
const snackbarStore = useSnackbarStore();

const preparedVersion = ref<PreparedVersion>();
const repositoryApiHandler = new RepositoryApiHandler();

const form: ref<FormWithoutButton> = ref<FormWithoutButton>();

watch(() => modalData.repository, () => {
  if (!modalData.repository) {
    return [];
  }

  repositoryApiHandler.prepareNewVersion(modalData.repository)
      .then((newPrepareVersion: PreparedVersion) => {
        preparedVersion.value = newPrepareVersion;
      })
      .catch((e) => snackbarStore.createMessagesFromError(e));
})

onMounted(() => {
  updateTypeEnumStore.init();
  versionTypeEnumStore.init();
})

const createRelease = () => {
  if (!preparedVersion.value) {
    return;
  }

  repositoryApiHandler.createNewVersion(preparedVersion.value);
}

</script>

<template>
  <BaseModal
      title="Création d'une nouvelle version"
      :visible="modalData.visible"
      :onHide="() => modalData.hide()"
  >
    <template #default>
      <FormWithoutButton
          :onSubmit="createRelease"
          ref="form"
          v-if="preparedVersion"
      >
        <Flex class="flex-col gap-content overflow-auto">
          <RepositoryNewVersionLine
              :key="'repository_'+ preparedVersion.repository.code"
              :preparedVersion="preparedVersion"
          />
          <RepositoryNewVersionLine
              :key="'repository_'+ submodule.repository.code"
              v-for="(submodule) of preparedVersion.submoduleReleases"
              :preparedVersion="submodule"
          />
        </Flex>
      </FormWithoutButton>
    </template>
    <template #footer>
      <ActionButton @click="() => form.executeSubmit()">Import</ActionButton>
    </template>
  </BaseModal>
</template>
